/*
Created Nice Aim Detector by sector for www.chatbox.do.am
Web Help - www.chatbox.do.am

All ingenious is simple - Nice. Made in Russia.
*/

#include <amxmodx>
#include <amxmisc>
#include <fun>
#include <csx>

#define nPlugin "Nice Aim Detector"

#define nHead_Ress "Head aim hack"
#define nChest_Ress "Chest aim hack"
#define nStomach_Ress "Stomach aim hack"
#define nLarm_Ress "Left arm aim hack"
#define nRarm_Ress "Right arm aim hack"
#define nLleg_Ress "Left leg aim hack"
#define nRleg_Ress "Right leg aim hack"

new nAim_Detector_Head[33]
new nAim_Detector_Chest[33]
new nAim_Detector_Stomach[33]
new nAim_Detector_Larm[33]
new nAim_Detector_Rarm[33]
new nAim_Detector_Lleg[33]
new nAim_Detector_Rleg[33]

new nAim_Detector_Warn_Head[33]
new nAim_Detector_Warn_Chest[33]
new nAim_Detector_Warn_Stomach[33]
new nAim_Detector_Warn_Larm[33]
new nAim_Detector_Warn_Rarm[33]
new nAim_Detector_Warn_Lleg[33]
new nAim_Detector_Warn_Rleg[33]

new nAim_Detector_Action[129], nReason[64], nName[33], nFortime

new nAim_Detector_Cvar_Headtime
new nAim_Detector_Cvar_Hittime
new nAim_Detector_Cvar_Fortime
new nAim_Detector_Cvar_Head
new nAim_Detector_Cvar_Hits
new nAim_Detector_Cvar_Warn
new nAim_Detector_Cvar_Bantime
new nAim_Detector_Cvar_Punishment

public plugin_init() 
{
	register_plugin(nPlugin, "1.3 A", "sector")
	
	register_dictionary("nice_aim_detector.txt")
	
	server_cmd("exec addons/amxmodx/configs/nice_aim_detector/nice_aim_detector.cfg")
	
	nAim_Detector_Cvar_Headtime = register_cvar("naim_detector_headtime", "")
	nAim_Detector_Cvar_Hittime = register_cvar("naim_detector_hittime", "")
	nAim_Detector_Cvar_Fortime = register_cvar("naim_detector_fortime", "")
	nAim_Detector_Cvar_Head = register_cvar("naim_detector_head", "")
	nAim_Detector_Cvar_Hits = register_cvar("naim_detector_hits", "")
	nAim_Detector_Cvar_Warn = register_cvar("naim_detector_warn", "")
	nAim_Detector_Cvar_Bantime = register_cvar("naim_detector_bantime", "")
	nAim_Detector_Cvar_Punishment = register_cvar("naim_detector_punishment", "")
}

public client_putinserver(id)
{
	nAim_Detector_Head[id] = 0
	nAim_Detector_Chest[id] = 0
	nAim_Detector_Stomach[id] = 0
	nAim_Detector_Larm[id] = 0
	nAim_Detector_Rarm[id] = 0
	nAim_Detector_Lleg[id] = 0
	nAim_Detector_Rleg[id] = 0
	
	nFortime = 0
	
	nAim_Detector_Warn_Head[id] = 0
	nAim_Detector_Warn_Chest[id] = 0
	nAim_Detector_Warn_Stomach[id] = 0
	nAim_Detector_Warn_Larm[id] = 0
	nAim_Detector_Warn_Rarm[id] = 0
	nAim_Detector_Warn_Lleg[id] = 0
	nAim_Detector_Warn_Rarm[id] = 0
	
	set_task(60.0, "nice_aim_detector_fortime", id, _, _, "b")
}

public client_disconnect(id)
{
	if(task_exists(id))
	{
		remove_task(id)
	}
}

public client_death(killer, victim, wpnindex, hitplace)
{
	if(is_user_alive(killer))
	{
		if(hitplace == HIT_HEAD)
		{
			nAim_Detector_Head[killer]++
			
			if(nAim_Detector_Head[killer] == 1)
			{
				set_task(get_pcvar_float(nAim_Detector_Cvar_Headtime), "nice_aim_detector_head_off", killer)
			}
			else
			if(nAim_Detector_Head[killer] >= get_pcvar_num(nAim_Detector_Cvar_Head))
			{
				get_user_name(killer, nName, 32)
				
				nAim_Detector_Warn_Head[killer]++
				
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_N", nName, nHead_Ress)
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_W", nAim_Detector_Warn_Head[killer], get_pcvar_num(nAim_Detector_Cvar_Warn))
				
				if(nAim_Detector_Warn_Head[killer] == get_pcvar_num(nAim_Detector_Cvar_Warn))
				{
					nReason = nHead_Ress
					
					nice_aim_detector_punishment(killer, nReason)
				}
			}
		}
	}
}

public client_damage(killer, victim, damage, wpnindex, hitplace)
{
	if(is_user_alive(killer))
	{
		if(hitplace == HIT_CHEST)
		{
			nAim_Detector_Chest[killer]++
			
			if(nAim_Detector_Chest[killer] == 1)
			{
				set_task(get_pcvar_float(nAim_Detector_Cvar_Hittime), "nice_aim_detector_chest_off", killer)
			}
			else
			if(nAim_Detector_Chest[killer] >= get_pcvar_num(nAim_Detector_Cvar_Hits))
			{
				get_user_name(killer, nName, 32)
				
				nAim_Detector_Warn_Chest[killer]++
				
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_N", nName, nChest_Ress)
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_W", nAim_Detector_Warn_Chest[killer], get_pcvar_num(nAim_Detector_Cvar_Warn))
				
				if(nAim_Detector_Warn_Chest[killer] == get_pcvar_num(nAim_Detector_Cvar_Warn))
				{
					nReason = nChest_Ress
					
					nice_aim_detector_punishment(killer, nReason)
				}
			}
		}
		else
		if(hitplace == HIT_STOMACH)
		{
			nAim_Detector_Stomach[killer]++
			
			if(nAim_Detector_Stomach[killer] == 1)
			{
				set_task(get_pcvar_float(nAim_Detector_Cvar_Hittime), "nice_aim_detector_stomach_off", killer)
			}
			else
			if(nAim_Detector_Stomach[killer] >= get_pcvar_num(nAim_Detector_Cvar_Hits))
			{
				get_user_name(killer, nName, 32)
				
				nAim_Detector_Warn_Stomach[killer]++
				
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_N", nName, nStomach_Ress)
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_W", nAim_Detector_Warn_Stomach[killer], get_pcvar_num(nAim_Detector_Cvar_Warn))
				
				if(nAim_Detector_Warn_Stomach[killer] == get_pcvar_num(nAim_Detector_Cvar_Warn))
				{
					nReason = nStomach_Ress
					
					nice_aim_detector_punishment(killer, nReason)
				}
			}
		}
		else
		if(hitplace == HIT_LEFTARM)
		{
			nAim_Detector_Larm[killer]++
			
			if(nAim_Detector_Larm[killer] == 1)
			{
				set_task(get_pcvar_float(nAim_Detector_Cvar_Hittime), "nice_aim_detector_larm_off", killer)
			}
			else
			if(nAim_Detector_Larm[killer] >= get_pcvar_num(nAim_Detector_Cvar_Hits))
			{
				get_user_name(killer, nName, 32)
				
				nAim_Detector_Warn_Larm[killer]++
				
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_N", nName, nLarm_Ress)
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_W", nAim_Detector_Warn_Larm[killer], get_pcvar_num(nAim_Detector_Cvar_Warn))
				
				if(nAim_Detector_Warn_Larm[killer] == get_pcvar_num(nAim_Detector_Cvar_Warn))
				{
					nReason = nLarm_Ress
					
					nice_aim_detector_punishment(killer, nReason)
				}
			}
		}
		else
		if(hitplace == HIT_RIGHTARM)
		{
			nAim_Detector_Rarm[killer]++
			
			if(nAim_Detector_Rarm[killer] == 1)
			{
				set_task(get_pcvar_float(nAim_Detector_Cvar_Hittime), "nice_aim_detector_rarm_off", killer)
			}
			else
			if(nAim_Detector_Rarm[killer] >= get_pcvar_num(nAim_Detector_Cvar_Hits))
			{
				get_user_name(killer, nName, 32)
				
				nAim_Detector_Warn_Rarm[killer]++
				
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_N", nName, nRarm_Ress)
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_W", nAim_Detector_Warn_Rarm[killer], get_pcvar_num(nAim_Detector_Cvar_Warn))
				
				if(nAim_Detector_Warn_Rarm[killer] == get_pcvar_num(nAim_Detector_Cvar_Warn))
				{
					nReason = nRarm_Ress
					
					nice_aim_detector_punishment(killer, nReason)
				}
			}
		}
		else
		if(hitplace == HIT_LEFTLEG)
		{
			nAim_Detector_Lleg[killer]++
			
			if(nAim_Detector_Lleg[killer] == 1)
			{
				set_task(get_pcvar_float(nAim_Detector_Cvar_Hittime), "nice_aim_detector_lleg_off", killer)
			}
			else
			if(nAim_Detector_Lleg[killer] >= get_pcvar_num(nAim_Detector_Cvar_Hits))
			{
				get_user_name(killer, nName, 32)
				
				nAim_Detector_Warn_Lleg[killer]++
				
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_N", nName, nLleg_Ress)
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_W", nAim_Detector_Warn_Lleg[killer], get_pcvar_num(nAim_Detector_Cvar_Warn))
				
				if(nAim_Detector_Warn_Lleg[killer] == get_pcvar_num(nAim_Detector_Cvar_Warn))
				{
					nReason = nLleg_Ress
					
					nice_aim_detector_punishment(killer, nReason)
				}
			}
		}
		else
		if(hitplace == HIT_RIGHTLEG)
		{
			nAim_Detector_Rleg[killer]++
			
			if(nAim_Detector_Rleg[killer] == 1)
			{
				set_task(get_pcvar_float(nAim_Detector_Cvar_Hittime), "nice_aim_detector_rleg_off", killer)
			}
			else
			if(nAim_Detector_Rleg[killer] >= get_pcvar_num(nAim_Detector_Cvar_Hits))
			{
				get_user_name(killer, nName, 32)
				
				nAim_Detector_Warn_Rleg[killer]++
				
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_N", nName, nRleg_Ress)
				nChatPrint(killer, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_W", nAim_Detector_Warn_Rleg[killer], get_pcvar_num(nAim_Detector_Cvar_Warn))
				
				if(nAim_Detector_Warn_Rleg[killer] == get_pcvar_num(nAim_Detector_Cvar_Warn))
				{
					nReason = nRleg_Ress
					
					nice_aim_detector_punishment(killer, nReason)
				}
			}
		}
	}
}
		

public nice_aim_detector_head_off(killer)
{
	nAim_Detector_Head[killer] = 0
}

public nice_aim_detector_chest_off(killer)
{
	nAim_Detector_Chest[killer] = 0
}

public nice_aim_detector_stomach_off(killer)
{
	nAim_Detector_Stomach[killer] = 0
}

public nice_aim_detector_larm_off(killer)
{
	nAim_Detector_Larm[killer] = 0
}

public nice_aim_detector_rarm_off(killer)
{
	nAim_Detector_Rarm[killer] = 0
}

public nice_aim_detector_lleg_off(killer)
{
	nAim_Detector_Lleg[killer] = 0
}

public nice_aim_detector_rleg_off(killer)
{
	nAim_Detector_Rleg[killer] = 0
}

public nice_aim_detector_punishment(killer, nReason[])
{
	new nIP[33], nAid[35], nUid[33], nBantime[6]
	
	get_user_name(killer, nName, 32)
	get_user_ip(killer, nIP, 32, 1)
	get_user_authid(killer, nAid, 34)
	
	num_to_str(get_user_userid(killer), nUid, 32)
	num_to_str(nAim_Detector_Cvar_Bantime, nBantime, 5)
	
	get_pcvar_string(nAim_Detector_Cvar_Punishment, nAim_Detector_Action, 128)
	
	nChatPrint(0, "^1[^4%s^1] %L", nPlugin, LANG_PLAYER, "NAIM_DETECTOR_MESS_C", nName, nReason)
	
	log_to_file("addons/amxmodx/configs/nice_aim_detector/nice_aim_detector.txt", "   [%s]   <%s>   <%s>", nPlugin, nName, nReason)
	
	client_print(killer, print_console, "")
	client_print(killer, print_console, "================[%s]================", nPlugin)
	client_print(killer, print_console, "")
	client_print(killer, print_console, "%L", LANG_PLAYER, "NAIM_DETECTOR_MESS_1", nName)
	client_print(killer, print_console, "%L", LANG_PLAYER, "NAIM_DETECTOR_MESS_2", nBantime)
	client_print(killer, print_console, "%L", LANG_PLAYER, "NAIM_DETECTOR_MESS_3", nReason)
	client_print(killer, print_console, "")
	client_print(killer, print_console, "================[%s]================", nPlugin)
	client_print(killer, print_console, "")
	
	replace_all(nAim_Detector_Action, 128, "%userid%", nUid)
	replace_all(nAim_Detector_Action, 128, "%ip%", nIP)
	replace_all(nAim_Detector_Action, 128, "%steamid%", nAid)
	replace_all(nAim_Detector_Action, 128, "%name%", nName)
	replace_all(nAim_Detector_Action, 128, "%reason%", nReason)
	replace_all(nAim_Detector_Action, 128, "%time%", nBantime)
	
	server_cmd(nAim_Detector_Action)
}

public nice_aim_detector_fortime(id)
{
	nFortime++
	
	if(nFortime == get_pcvar_num(nAim_Detector_Cvar_Fortime))
	{
		nAim_Detector_Warn_Head[id] = 0
		nAim_Detector_Warn_Chest[id] = 0
		nAim_Detector_Warn_Stomach[id] = 0
		nAim_Detector_Warn_Larm[id] = 0
		nAim_Detector_Warn_Rarm[id] = 0
		nAim_Detector_Warn_Lleg[id] = 0
		nAim_Detector_Warn_Rarm[id] = 0
		
		nFortime = 0
	}
}

stock nChatPrint(const id, const input[], any:...)
{
	 new nCount = 1, nNum[32]
	 
	 static nMsgs[191]
	 
	 vformat(nMsgs, 190, input, 3)
	 
	 replace_all(nMsgs, 190, "!g", "^4")
	 replace_all(nMsgs, 190, "!n", "^1")
	 replace_all(nMsgs, 190, "!t", "^3")

	 
	 if(id) nNum[0] = id; else get_players(nNum, nCount, "ch")
	 {
	 	for(new i = 0; i < nCount; i++)
		{
			if(is_user_connected(nNum[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, nNum[i])
				
				write_byte(nNum[i])
				
				write_string(nMsgs)
				
				message_end()
			}
		}
	}
}